//  (C) Copyright Michele Caini 2013.

//  Use, modification and distribution are subject to the Boost Software License,
//  Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt).
//
//  See http://www.boost.org/libs/type_traits for most recent version including documentation.


#ifndef BOOST_TT_ARE_SAME_HPP_INCLUDED
#define BOOST_TT_ARE_SAME_HPP_INCLUDED

#ifdef BOOST_NO_0X_HDR_TYPE_TRAITS
#include <boost/type_traits/is_same.hpp>
using boost::is_same;
#else // BOOST_NO_0X_HDR_TYPE_TRAITS
#include <type_traits>
using std::is_same;
#endif // BOOST_NO_0X_HDR_TYPE_TRAITS

namespace boost {

#ifndef BOOST_NO_VARIADIC_TEMPLATES
template <typename... O>
struct are_same;

template <typename T, typename... O>
struct are_same<T, T, O...>: public are_same<T, O...> { };

template <typename T, typename U, typename... O>
struct are_same<T, U, O...>: public is_same<T, U> { };

template <typename T>
struct are_same<T, T>: public is_same<T, T> { };

template <typename T, typename U>
struct are_same<T, U>: public is_same<T, U> { };
#else // BOOST_NO_VARIADIC_TEMPLATES
#ifndef BOOST_NO_TEMPLATE_ALIASES
template <typename T>
using are_same = is_same<T, T>

template <typename T, typename U>
using are_same = is_same<T, U>
#else // BOOST_NO_TEMPLATE_ALIASES
template <typename T>
struct are_same<T, T>: public is_same<T, T> { };

template <typename T, typename U>
struct are_same<T, U>: public is_same<T, U> { };
#endif // BOOST_NO_TEMPLATE_ALIASES
#endif // BOOST_NO_VARIADIC_TEMPLATES

}

#endif // BOOST_TT_ARE_SAME_HPP_INCLUDED
