//  (C) Copyright Michele Caini 2013. 
//  Use, modification and distribution are subject to the 
//  Boost Software License, Version 1.0. (See accompanying file 
//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include "test.hpp"
#include "check_integral_constant.hpp"
#include <boost/type_traits/are_same.hpp>

TT_TEST_BEGIN(are_same)

BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int>::value), true);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&, int&>::value), true);
#ifndef BOOST_NO_CXX11_RVALUE_REFERENCES
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&&, int&&>::value), true);
#endif
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, const int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int&>::value), false);
#ifndef BOOST_NO_CXX11_RVALUE_REFERENCES
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int&&>::value), false);
#endif
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<const int, int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, const int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, const int*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, int*const>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int[4], int[2]>::value), false);

BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int, int>::value), true);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&, int&, int&>::value), true);
#ifndef BOOST_NO_CXX11_RVALUE_REFERENCES
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&&, int&&, int&&>::value), true);
#endif
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int, const int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, const int, int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<const int, int, int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int, int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int&, int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&, int, int>::value), false);
#ifndef BOOST_NO_CXX11_RVALUE_REFERENCES
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int, int&&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int&&, int>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int&&, int, int>::value), false);
#endif
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<const int, int&, unsigned short>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<const int, unsigned long, int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<unsigned char, const int, int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, const int&, unsigned short>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, unsigned long, const int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<unsigned char, int, const int&>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, const int*, char*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, char*, const int*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<char*, int*, const int*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, int*const, long*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, long*, int*const>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<long*, int*, int*const>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int[2], int*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int*, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int, int*, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, int[2], char[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, char[2], int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<char[2], int*, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int[4], int[2], int*>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int[4], int*, int[2]>::value), false);
BOOST_CHECK_INTEGRAL_CONSTANT((::tt::are_same<int*, int[4], int[2]>::value), false);


TT_TEST_END
